%GA12 - loha 2 (Oskulacn elementy druzice)
clear;
clc;

kepler2003_413; %zadn (vstupn data)

GM = 3.986004418e14; %m^3/s^2
ro = 180/pi;                    

fid = fopen('ga12_u02.txt','w');


for ii=1:10
    datum = data(ii,2:4);
    cas = data(ii,5) * 3600 + data(ii,6) * 60 + data(ii,7); %[sec]
    fprintf(fid,'epocha: %.f (%02.f.%02.f.%.f  %2.f:%02.f:%02.f)\n',ii,datum,c2dms(cas/3600));
    Vec_r = data(ii,8:10);
    Vec_rt = data(ii,11:13);
    
    r = (Vec_r * Vec_r')^0.5; %dlka pruvodice r
    V = (Vec_rt * Vec_rt')^0.5; %rychlost druzice V
    Vec_c = vec_soucin(Vec_r,Vec_rt); %Vec hybnosti c
    c = norm(Vec_c); %hybnost  <(Vec_c * Vec_c')^0.5>

    %hlavn poloosa a z integrli ziv sly
    a = 1/(2 / r - V^2 / GM);
    fprintf(fid,'             hlavn poloosa a = %.3f m\n',a);
    
    %excentricita e z vrazu pro parametr elipsy
    e = (1 - c^2 / (GM * a))^0.5;
    fprintf(fid,'               excentricita e = %.9f\n',e);
    
    %prav anomlie
    v = acos( ((a*(1-e^2)) / (r*e)) - 1/e );
    
    pom = Vec_r * Vec_rt';
    
    if(pom > 0) %osetreni kvadrantu
        v = v;
    elseif(pom < 0)
        v = 2*pi - v;
    elseif((pom == 0) & (r <= a))
        v = 0;
    elseif((pom == 0) & (r > a))
        v = pi;
    end
    
    E = 2 * atan( ( ((1-e)/(1+e))^0.5 ) * tan(v/2) );%excentrick anomlie
    M = E - e * sin(E);%stredn anomlie v case T
    n = (GM / a^3)^0.5; %stredn denn pohyb
    T = cas;
%   M = n*(T-T0);    
    T0 = T - M/n;%cas pruchodu pericentrem
    fprintf(fid,'  cas pruchodu pericentrem T0 = %2.f:%02.f:%03.1f\n',c2dms(T0/3600));
    fprintf(fid,'           stredn anomlie M = %3.f%02.f''%05.2f''''\n',c2dms(ro*M));
    
    W = atan2(Vec_c(1),-Vec_c(2));%rektanscenze vystupniho uzlu
    if(W < 0)
        W = W + 2*pi;
    end
    fprintf(fid,'rektascenze vstupnho uzlu W = %3.f%02.f''%05.2f''''\n',c2dms(ro*W));

    i = acos(Vec_c(3)/c);%sklon drhy
    fprintf(fid,'         sklon roviny drhy i = %3.f%02.f''%05.2f''''\n',c2dms(ro*i));
    
    Vec_e3 = [0 0 1];
    
    Vec_s = vec_soucin(Vec_e3,Vec_c);
    s = norm(Vec_s);
    
    pom = acos((Vec_s * Vec_r') / (s * r));
    
    if(Vec_r(3) < 0)
        pom = -pom;
    end
    
    w = pom - v;%vzdlenost pericentra
    
    if(w < 0)
        w = w + 2*pi;
    end
    
    fprintf(fid,'        argument pericentra w = %3.f%02.f''%05.2f''''\n',c2dms(ro*w));
    
    
    fprintf(fid,'\n----------------------------------------------------\n');
    
    a_(ii) = a;
    e_(ii) = e;
    v_(ii) = v;
    M_(ii) = M;
    T0_(ii) = T0;
    
    W_(ii) = W;
    i_(ii) = i;
    w_(ii) = w;
        
    
end

fclose(fid);

%GRAFY

ep = 1:10;

clf;%smazat graf
cla;%smazat osy
hold on;
title('casov zmena hlavn poloosy \ita');
xlabel('epocha');
ylabel('hlavn poloosa \ita\rm [m]');
plot(ep,a_);
print -f1 -dpng 'ga12_u02.1(a).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
title('casov zmena excentricity \ite');
xlabel('epocha');
ylabel('excentricita \ite');
plot(ep,e_);
print -f1 -dpng 'ga12_u02.2(e).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
title('casov zmena casu pruchodu pericentrem \itT_{0}');
xlabel('epocha');
ylabel('cas pruchodu pericentrem \itT_{0}\rm [sec]');
plot(ep,T0_);
print -f1 -dpng 'ga12_u02.3a(T0).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
title('casov zmena stredn anomlie \itM');
xlabel('epocha');
ylabel('stredn anomlie \itM\rm []');
plot(ep,ro*M_);
print -f1 -dpng 'ga12_u02.3b(M).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
title('casov zmena rektascenze vstupnho uzlu \Omega');
xlabel('epocha');
ylabel('rektascenze vstupnho uzlu \Omega []');
plot(ep,ro*W_);
print -f1 -dpng 'ga12_u02.4(W).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
title('casov zmena sklonu roviny drhy \iti');
xlabel('epocha');
ylabel('sklon roviny drhy \iti\rm []');
plot(ep,ro*i_);
print -f1 -dpng 'ga12_u02.5(i).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
title('casov zmena argumentu perigea \omega');
xlabel('epocha');
ylabel('argument perigea \omega []');
plot(ep,ro*w_);
print -f1 -dpng 'ga12_u02.6(w).png'; %automaticky export do *.png
hold off;